<script setup lang="ts">
import { ref } from 'vue'
import { useI18n } from 'vue-i18n'
import { useRouter } from 'vue-router'
import { MemberProfile } from '../../models/member_profile.entity'
import { useAppStore } from '../../stores/AppStore'
import { useMemberStore } from '../../stores/MemberStore'

// using
const { t } = useI18n({
	messages: {
		en: {
			title: `Google Sign-In`,
			confirm: `Confirm Sign-Up`,
		},
		th: {
			title: `เข้าระบบ กูเกิล`,
			confirm: `ยืนยันการสมัคร`,
		},
	},
})
const router = useRouter()
const appStore = useAppStore()
const memberStore = useMemberStore()

// state
const dummy = ref()

async function confirm(): Promise<void> {
	// calls REST
	console.log(`dummy: ${JSON.stringify(dummy.value, null, 2)}`)
	const result = await memberStore.client.call(`member/authenx/google`, {
		method: 'POST',
		data: {
			signUp: {
				access_token: dummy.value.token.access_token,
				id_token: dummy.value.token.id_token,
			},
		},
	})
	if (appStore.handleRestResultUi(result))
		return

	// success, retrieves REST data
	dummy.value = result.json
	if (dummy.value.profile) {
		memberStore.setProfileState(new MemberProfile(result.json.profile), result.json.profile.credential.token)
		router.push({ path: '/' })
	}
}

async function setup(): Promise<void> {
	// calls REST
	const result = await memberStore.client.call(`member/authenx/google${window.location.search}`, {
		method: 'GET',
	})
	if (appStore.handleRestResultUi(result))
		return

	// success, retrieves REST data
	dummy.value = result.json
	if (dummy.value.profile) {
		memberStore.setProfileState(new MemberProfile(result.json.profile), result.json.profile.credential.token)
		router.push({ path: '/' })
	}
}
setup()
</script>


<template>
	<AppBox :hideRightMenu="true" :title="t('title')">
		<div style="white-space:pre-wrap">
			{{ JSON.stringify(dummy, null, 2) }}
		</div>

		<div>
			<button @click.prevent="(e: Event) => confirm()">{{ t('confirm') }}</button>
		</div>
	</AppBox>
</template>
